(function()
{

var csInterface = new CSInterface();

/* Used to initalize the event listeners */
function init()
{
  if(window.__adobe_cep__ != undefined)
  {
    updateTheme();
    csInterface.addEventListener(CSInterface.THEME_COLOR_CHANGED_EVENT, updateTheme);
  }
  else
  {
    window.document.body.style.setProperty("background-color", "rgb(38,38,38)");
    window.document.body.style.setProperty("font-size", "11px");
    window.document.body.style.setProperty("color", "#8a8a8a");
    window.document.body.style.setProperty("--host-hlgt", "rgb(0,120,215)");
    window.document.body.style.setProperty("--host-bgc", "rgb(38,38,38)");
  }
}

/* Updates the panel look to match the host app */
function updateTheme()
{
  var skinInfo = JSON.parse(window.__adobe_cep__.getHostEnvironment()).appSkinInfo;

  // Background Colour info, conversion to RGB format (and rounding)
  let colourBackground = skinInfo.panelBackgroundColor.color;
  colourBackground = "rgb(" + Math.round(colourBackground.red) + "," + Math.round(colourBackground.green) + "," + Math.round(colourBackground.blue) + ")";

  // Font size info, conversion to CSS readable format
  let fontSize = skinInfo.baseFontSize;
  fontSize = String(fontSize + 1) + "px";

  // Highlight Colour info, conversion to RGB format (and rounding)
  let colourHighlight = skinInfo.systemHighlightColor;
  colourHighlight = "rgb(" + Math.round(colourHighlight.red) + "," + Math.round(colourHighlight.green) + "," + Math.round(colourHighlight.blue) + ")";

  window.document.body.style.setProperty("background-color", colourBackground);
  window.document.body.style.setProperty("font-size", fontSize);
  window.document.body.style.setProperty("color", "#8a8a8a");
  window.document.body.style.setProperty("--host-hlgt", colourHighlight);
  window.document.body.style.setProperty("--host-bgc", colourBackground);
}

init();
console.log("Theme Module Loaded");

})()
